Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# KeyC Class Reference

Keyframe class for controller. More...

`#include <KeyC.h>`

Inheritance diagram for KeyC:

List of all members.

## Public Member Functions
virtual Edit::DataBlockI * | create ()
| Create new key with zero no channels.
virtual Edit::DataBlockI * | create (Edit::EditableI *pOriginal)
| Creates new file handle (used internally), see Edit::EditableI::create().
virtual void | copy (Edit::EditableI *pEditable)
| Deep copy from a data block, see Edit::DataBlockI::copy().
virtual void | restore (Edit::EditableI *pEditable)
| Shallow copy from a editable, see Edit::EditableI::restore().
virtual PajaTypes::int32 | get_time ()
| Returns the time of the key.
virtual void | set_time (PajaTypes::int32 i32Time)
| Sets the time of the key.
virtual void | set_flags (PajaTypes::int32 i32Flags)
| Sets the effect flags.
virtual void | add_flags (PajaTypes::int32 i32Flags)
| Sets only specified flags.
virtual void | del_flags (PajaTypes::int32 i32Flags)
| Removes only specified flags.
virtual void | toggle_flags (PajaTypes::int32 i32Flags)
| Toggles only specified flags.
virtual PajaTypes::int32 | get_flags ()
| Returns key flags.
virtual PajaTypes::uint32 | save (FileIO::SaveC *pSave)
| Serialize the key to a Demopaja output stream.
virtual PajaTypes::uint32 | load (FileIO::LoadC *pLoad)
| Serialize the key from a Demopaja input stream.
## Static Public Member Functions
KeyC * | create_new ()
| Create new key with zero no channels.
## Protected Member Functions
| KeyC ()
| Default constructor.
| KeyC (PajaTypes::int32 i32Time)
| Creates new key and assign it the specified time.
| KeyC (Edit::EditableI *pOriginal)
| Constructor with reference to the original.
virtual | ~KeyC ()
| Default destructor.
## Protected Attributes
PajaTypes::int32 | m_i32Flags
PajaTypes::int32 | m_i32Time

## Detailed Description

Keyframe class for controller.

Key class defines the keys used in controllers. There are two type of keys: Float keys and file keys. The KeyC class is used in cases where only the time value is used.

Use key flags to indentity the different key types.

This class is implemented by the system.

## Constructor & Destructor Documentation

KeyC | ( |  | ) | `[protected]`

| Default constructor.

KeyC | ( | PajaTypes::int32 | i32Time | ) | `[protected]`

| Creates new key and assign it the specified time.

KeyC | ( | Edit::EditableI * | pOriginal | ) | `[protected]`

| Constructor with reference to the original.

virtual ~KeyC | ( |  | ) | `[protected, virtual]`

| Default destructor.

## Member Function Documentation

virtual void add_flags | ( | PajaTypes::int32 | i32Flags | ) | `[virtual]`

| Sets only specified flags.

virtual void copy | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Implements EditableI. Reimplemented in FloatKeyC, and FileKeyC.

virtual Edit::DataBlockI* create | ( | Edit::EditableI * | pOriginal | ) | `[virtual]`

| Creates new file handle (used internally), see Edit::EditableI::create(). Implements EditableI. Reimplemented in FloatKeyC, and FileKeyC.

virtual Edit::DataBlockI* create | ( |  | ) | `[virtual]`

| Create new key with zero no channels. Implements EditableI. Reimplemented in FloatKeyC, and FileKeyC.

KeyC* create_new | ( |  | ) | `[static]`

| Create new key with zero no channels. Reimplemented in FloatKeyC, and FileKeyC.

virtual void del_flags | ( | PajaTypes::int32 | i32Flags | ) | `[virtual]`

| Removes only specified flags.

virtual PajaTypes::int32 get_flags | ( |  | ) | `[virtual]`

| Returns key flags.

virtual PajaTypes::int32 get_time | ( |  | ) | `[virtual]`

| Returns the time of the key.

virtual PajaTypes::uint32 load | ( | FileIO::LoadC * | pLoad | ) | `[virtual]`

| Serialize the key from a Demopaja input stream. Implements EditableI. Reimplemented in FloatKeyC, and FileKeyC.

virtual void restore | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Implements EditableI. Reimplemented in FloatKeyC, and FileKeyC.

virtual PajaTypes::uint32 save | ( | FileIO::SaveC * | pSave | ) | `[virtual]`

| Serialize the key to a Demopaja output stream. Implements EditableI. Reimplemented in FloatKeyC, and FileKeyC.

virtual void set_flags | ( | PajaTypes::int32 | i32Flags | ) | `[virtual]`

| Sets the effect flags. Be careful to use this method. There are some flags, which have to be in place to make the key work correctly. Use add, del or toggle flags methods instead.

virtual void set_time | ( | PajaTypes::int32 | i32Time | ) | `[virtual]`

| Sets the time of the key.

virtual void toggle_flags | ( | PajaTypes::int32 | i32Flags | ) | `[virtual]`

| Toggles only specified flags.